import { useEffect, useRef, useState } from "react";
import { Subject, takeUntil, tap } from "rxjs";
import { produce } from "immer";
export const useObservableSubscribe = props => {
  const [state, setState] = useState({});
  const destroy$Ref = useRef(props.destroy$ ? props.destroy$ : new Subject());
  const obs$ = props.obs$;
  const destroy$ = destroy$Ref.current;
  useEffect(() => {
    obs$.pipe(takeUntil(destroy$), tap(value => {
      setState(produce(draft => {
        draft.value = value;
      }));
    }, error => {
      setState(produce(draft => {
        draft.error = error;
      }));
    }, () => {
      setState(produce(draft => {
        draft.completed = true;
      }));
    })).subscribe();
    return () => {
      destroy$.next();
      destroy$.complete();
    };
  }, [obs$, destroy$]);
  return state;
};