"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.MockServer = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _rxjs = require("rxjs");

class MockServer {
  constructor(config) {
    this.config = config;
  }

  getConfig() {
    const sum = this.config.responses.reduce((t, e) => t + e.ocurrence, 0);
    const ranges = this.config.responses.map(resp => {
      return (0, _extends2.default)({}, resp, {
        percentil: Math.floor(resp.ocurrence * 100 / sum)
      });
    }).reduce((t, e) => {
      const lastRange = t.length > 0 ? t[t.length - 1] : {
        top: 0,
        bottom: 0
      };
      return [...t, (0, _extends2.default)({}, e, {
        top: lastRange.top + e.percentil,
        bottom: lastRange.top
      })];
    }, []);
    const randomValue = Math.floor(Math.random() * 100);
    return ranges.find(range => randomValue > range.bottom && randomValue <= range.top);
  }

  invoke() {
    return (0, _rxjs.of)('').pipe((0, _rxjs.concatMap)(_ => (0, _rxjs.of)(this.getConfig())), (0, _rxjs.take)(1), (0, _rxjs.delay)(this.config.time || Math.random() * 3000), (0, _rxjs.map)(config => {
      const data = config.data;
      if (config.isError) throw data;
      return data;
    }));
  }

}

exports.MockServer = MockServer;

MockServer.create = config => {
  return new MockServer(config);
};

;